<template>
  <el-row :gutter="32">
    <el-col :xs="24" :sm="24" :lg="14" class="small-table">
      <el-table :data="status_farmer" fit highlight-current-row style="width: 100%;">
        <el-table-column style="width: calc(100% - 170);" align="left">
          <template slot-scope="scope">
            <div class="box" v-bind:style="scope.row.color"></div>
            <span>{{ scope.row.status || '-'}}</span>
          </template>
        </el-table-column>
        <el-table-column width="90" align="right">
          <template slot-scope="scope">
            <span>{{ (scope.row.percent).toFixed(2) }} %</span>
          </template>
        </el-table-column>
        <el-table-column width="80" align="right">
          <template slot-scope="scope">
            <div class="farmer-count farmer-count--decimal">
              {{ scope.row.farmer_count }}
              <svg-icon icon-class="people-dark-green" />
            </div>
          </template>
        </el-table-column>
      </el-table>
    </el-col>
    <el-col :xs="24" :sm="24" :lg="10">
      <GChart
        v-loading="loading"
        type="PieChart"
        :data="chartData"
        :options="chartOptions"
        :resizeDebounce="500"
        :key="rerender"
        @ready="onChartReady"
      />
    </el-col>
  </el-row>
</template>
<script>
import { GChart } from 'vue-google-charts';
export default {
  name: 'FarmerStatus',
  components: {
    GChart
  },
  data() {
    return {
      chartData: null,
      loading: true,
      rerender: 0,
      chartOptions: {
        chart: {
          title: 'Farmer chart by gender',
          subtitle: 'Jenis kelamin'
        },
        animation: {
          duration: 1200,
          easing: 'out',
          startup: true
        },
        height: 300,
        pieHole: 0.65,
        pieSliceText: 'none',
        slices: [
          { color: '#ff4343' },
          { color: '#74bd40' },
          { color: '#f9bc3f' },
          { color: '#0092d2' },
          { color: '#0e5faf' },
          { color: '#b9e4ea' },
          { color: '#cce4bb' },
          { color: '#ece3bb' },
          { color: '#f7d1c7' }
        ],
        legend: {
          position: 'none',
          align: 'left',
          textStyle: {
            color: { color: '#373737' },
            fontName: 'Nunito',
            fontSize: 18,
            bold: 1
          }
        },
        tooltip: {
          ignoreBounds: true,
          isHtml: true,
          trigger: 'selection'
        }
      }
    };
  },
  computed: {
    status_farmer: {
      get: function() {
        var fs = this.$store.state.farmer.farmers.farmer_by_status;
        if (fs) {
          var i;
          var filtered_fs = [];
          var count = 0;
          for (i = 0; i < 7; i++) {
            const new_fs = {
              color: {
                backgroundColor: this.chartOptions.slices[i].color
              },
              farmer_count: fs[i]['farmer_count'],
              status: fs[i]['status'],
              percent: 0
            }
            if (!(fs[i]['status']).includes('Non Aktif')) {
              filtered_fs.push(new_fs)
              if (filtered_fs[i].status === 'Aktif') {
                filtered_fs[i].status = 'Petani Mencatat Aktivitas'
              }
              count = count + fs[i]['farmer_count']
            }
          }
          for (i = 0; i < filtered_fs.length; i++) {
            filtered_fs[i]['percent'] = (filtered_fs[i]['farmer_count'] / count) * 100;
          }
          return filtered_fs;
        } else {
          return this.$store.state.farmer.farmers.farmer_by_status;
        }
      }
    }
  },
  watch: {
    status_farmer(newLocation, oldLocation) {
      this.dataLocs = newLocation;
      this.rerender = this.rerender + 1;
    }
  },
  methods: {
    onChartReady(chart, google) {
      this.loading = true;
      this.createDataTable(chart, google);
      setTimeout(() => {
        this.loading = false;
      }, 1.5 * 1000);
    },
    createDataTable(chart, google) {
      const dataArray = [];

      this.dataLocs = this.status_farmer;

      if (this.dataLocs !== null) {
        this.dataLocs.forEach((el, index) => {
          // if (index < 5) {
          dataArray.push([el.status, el.farmer_count]);
          // }
        });
      }
      const total = getTotal(dataArray);

      for (let i = 0; i < dataArray.length; i++) {
        dataArray[i].push(customTooltip(dataArray[i][0], dataArray[i][1], total));
      }

      // Changing legend
      for (let i = 0; i < dataArray.length; i++) {
        dataArray[i][0] =
          dataArray[i][0] + ' ' + ((dataArray[i][1] / total) * 100).toFixed(2) + '% ' + dataArray[i][1] + ` Petani`;
      }

      // Column names
      dataArray.unshift(['Location', 'Percentage', 'Tooltip']);

      const dataTable = google.visualization.arrayToDataTable(dataArray);
      dataTable.setColumnProperty(2, 'role', 'tooltip');
      dataTable.setColumnProperty(2, 'html', true);
      dataTable.setColumnProperty(0, 'className', 'jajal');

      function customTooltip(name, value, total) {
        return (
          '<div class="location-tooltip">' +
          '<table class="location-tooltip__box"><tr><td><b>' +
          name +
          '<br/></b></td></tr><tr><td><b>' +
          value +
          '</b><span><img src="https://user-core.s3-ap-southeast-1.amazonaws.com/assets/people-dark-green.svg" /></span></td><td><span><b>(' +
          ((value / total) * 100).toFixed(2) +
          '%)</b></span></td></tr></table></div>'
        );
      }

      function getTotal(dataArray) {
        let total = 0;
        for (let i = 0; i < dataArray.length; i++) {
          total += dataArray[i][1];
        }
        return total;
      }
      this.chartData = dataTable;
      chart.draw(dataTable, this.chartOptions);
    }
  }
};
</script>
<style rel="stylesheet/scss" lang="scss" >
@import '@/styles/variables.scss';
@import '@/styles/mixin.scss';
.google-visualization-tooltip {
  border: none !important;
  box-shadow: none !important;
}
.location-tooltip {
  display: block;
  padding: 10px;
  @include ritx-box;

  &__box {
    td {
      display: inline-flex;
      align-items: center;
    }
  }

  .location-tooltip__featured {
    width: 40px;
    height: 40px;
  }

  table {
    td {
      vertical-align: middle;
      font-size: 18px;
      a {
        font-size: 18px;
        display: inline-flex;
        align-items: center;
        color: #f9bc3f;
      }
    }
  }

  img {
    padding: 5px;
    width: 25px;
    height: 25px;
  }
}

.farmer-count {
  display: inline-block;
  color: #086939;
  font-weight: 700;
  margin-top: 10px;
  &--decimal {
    float: right;
  }

  .svg-icon {
    width: 12px;
    height: 12px;
    vertical-align: 0;
  }
}

.box {
  width: 16px;
  height: 16px;
  background-color: #ff4343;
  margin-right: 10px;
  display: inline-block;
}

.small-table {
  .el-table--medium td {
    padding: 7px 0;
  }
}
</style>
